import "./style.css";
import { reactive as w, ref as N, watchEffect as D, onActivated as j, nextTick as F, onBeforeUnmount as x, resolveComponent as f, openBlock as T, createElementBlock as V, createElementVNode as l, createVNode as v, withCtx as P, withDirectives as W, vShow as A } from "vue";
import { Button as J } from "@opentiny/vue";
import { VueMonaco as O, CloseIcon as U, LinkButton as H } from "@opentiny/tiny-engine-common";
import { useCanvas as g, useNotify as y, useModal as E, useHelp as I } from "@opentiny/tiny-engine-meta-register";
import { initCompletion as z } from "@opentiny/tiny-engine-common/js/completion";
import { lint as R, initLinter as Y } from "@opentiny/tiny-engine-common/js/linter";
import { insertName as q, string2Ast as b, formatString as G, ast2String as K } from "@opentiny/tiny-engine-common/js/ast";
import { constants as Q } from "@opentiny/tiny-engine-utils";
import { isFunction as X } from "@opentiny/vue-renderless/grid/static";
const { SCHEMA_DATA_TYPE: k } = Q, r = w({
  linterWorker: null,
  script: "",
  isChanged: !1,
  hasError: !1,
  editorSelection: null,
  completionProvider: null
}), a = N(null);
let _ = null;
const C = () => {
  var e, n;
  const o = ((n = (e = g()).getSchema) == null ? void 0 : n.call(e)) || {};
  return o.methods = (o == null ? void 0 : o.methods) || {}, o.methods;
}, Z = () => g().pageState.pageSchema && Object.keys(C()) || [], M = () => {
  const e = Object.entries(C()).map(([n, t]) => q(n, t.value)).join(`
`);
  try {
    _ = b(e);
  } catch (n) {
    y({
      type: "error",
      message: `代码静态检查有错误：${n}`
    });
  }
  return e;
}, $ = (o) => {
  if (r.isChanged = o !== r.script, !a.value)
    return;
  const e = a.value.getEditor().getModel();
  R(e, r.linterWorker);
}, ee = ({ name: o, content: e }) => {
  if (!o)
    return;
  const n = C(), t = {
    type: k.JSFunction,
    value: e
  };
  g().updateSchema({ methods: { ...n, [o]: t } });
}, B = () => {
  const { message: o } = E();
  if (!r.isChanged)
    return !1;
  if (r.hasError)
    return o({
      status: "error",
      message: "代码静态检查有错误，请先修改后再保存"
    }), !1;
  const e = a.value.getEditor().getValue(), n = b(e), t = {};
  return n.program.body.forEach((s, i) => {
    var m, u;
    const d = (m = s == null ? void 0 : s.id) == null ? void 0 : m.name;
    (u = n.program.body[i + 1]) != null && u.leadingComments && s.trailingComments === n.program.body[i + 1].leadingComments && delete s.trailingComments;
    const p = G(K(s).trim(), "javascript");
    d && (t[d] = {
      type: k.JSFunction,
      value: p
    });
  }), g().updateSchema({ methods: t }), g().setSaved(!1), r.isChanged = !1, y({
    type: "success",
    message: "保存成功！"
  }), !0;
}, te = (o) => (e) => {
  const { confirm: n } = E(), t = X(e) ? e : () => o("close");
  if (!r.isChanged) {
    t(!0);
    return;
  }
  n({
    title: "提示",
    message: "有改动未保存，您确定保存并关闭吗？",
    exec() {
      t(B());
    },
    cancel() {
      t(!0);
    }
  });
}, oe = () => {
  if (!r.editorSelection || !a.value)
    return;
  const o = a.value.getEditor();
  o.setSelection(r.editorSelection), o.focus();
  const e = o.getTopForLineNumber(r.editorSelection.startLineNumber - 1);
  o.setScrollPosition(
    {
      scrollLeft: 0,
      scrollTop: e
    },
    0
  );
}, ne = (o) => {
  var t;
  if (!o)
    return;
  const e = _ == null ? void 0 : _.program.body.filter((s) => {
    var i;
    return o === ((i = s == null ? void 0 : s.id) == null ? void 0 : i.name);
  });
  if (e.length === 0)
    return;
  const n = (t = e[0]) == null ? void 0 : t.loc;
  n && (r.editorSelection = {
    startColumn: n.start.column,
    startLineNumber: n.start.line,
    endColumn: n.end.column + 1,
    endLineNumber: n.end.line
  }), r.editorSelection && oe();
}, se = ({ emit: o }) => (D(() => {
  r.script = M();
}), j(() => {
  F(() => {
    var e;
    r.script = M(), (e = a.value) == null || e.focus(), window.dispatchEvent(new Event("resize"));
  });
}), {
  state: r,
  monaco: a,
  change: $,
  saveMethods: B,
  close: te(o)
}), re = (o, e) => {
  const n = o.__vccOpts || o;
  for (const [t, s] of e)
    n[t] = s;
  return n;
}, ie = {
  saveMethod: ee,
  highlightMethod: ne,
  getMethodNameList: Z,
  getMethods: C
}, ce = {
  components: {
    MonacoEditor: O,
    TinyButton: J,
    CloseIcon: U,
    LinkButton: H
  },
  emits: ["close"],
  setup(o, { emit: e }) {
    const n = I().getDocsUrl("script"), { state: t, monaco: s, change: i, close: d, saveMethods: p } = se({ emit: e }), m = {
      language: "javascript",
      minimap: {
        enabled: !1
      },
      placeholder: `// ✅ 函数声明可以保存
      
 function topLevelFunction(){ 

      ​ ​ const message = 'hello tiny-engine.' 

      ​ ​ console.log(message) 
      
 }
      
 
      // ❌ 顶层/常规 变量声明 
 const someVariable = 42 

      // ❌ 表达式 
 const result = someVariable + 10`,
      // 禁用滚动条边边一直显示的边框
      overviewRulerBorder: !1,
      renderLineHighlightOnlyWhenFocus: !0
    }, u = (h) => {
      var c;
      s.value && (t.completionProvider = z(s.value.getMonaco(), (c = s.value.getEditor()) == null ? void 0 : c.getModel()), t.linterWorker = Y(h, s.value.getMonaco(), t));
    };
    return x(() => {
      var h, c, S;
      (h = t.completionProvider) == null || h.forEach((L) => {
        L.dispose();
      }), (S = (c = t.linterWorker) == null ? void 0 : c.terminate) == null || S.call(c);
    }), {
      state: t,
      monaco: s,
      options: m,
      close: d,
      change: i,
      saveMethods: p,
      editorDidMount: u,
      docsUrl: n
    };
  }
}, le = { class: "plugin-page-js-container" }, ae = { class: "code-edit-head" }, de = { class: "head-left" }, me = { class: "head-right" }, ue = { class: "dots" }, pe = { class: "code-edit-content" };
function ge(o, e, n, t, s, i) {
  const d = f("link-button"), p = f("tiny-button"), m = f("close-icon"), u = f("monaco-editor");
  return T(), V("div", le, [
    l("div", ae, [
      l("div", de, [
        e[0] || (e[0] = l("span", { class: "title" }, "页面 JS", -1)),
        v(d, { href: t.docsUrl }, null, 8, ["href"])
      ]),
      l("div", me, [
        v(p, {
          type: "primary",
          class: "save-btn",
          onClick: t.saveMethods
        }, {
          default: P(() => [
            e[1] || (e[1] = l("span", null, "保存", -1)),
            W(l("span", ue, null, 512), [
              [A, t.state.isChanged]
            ])
          ]),
          _: 1
        }, 8, ["onClick"]),
        v(m, { onClose: t.close }, null, 8, ["onClose"])
      ])
    ]),
    l("div", pe, [
      v(u, {
        ref: "monaco",
        value: t.state.script,
        options: t.options,
        onChange: t.change,
        onEditorDidMount: t.editorDidMount
      }, null, 8, ["value", "options", "onChange", "onEditorDidMount"])
    ])
  ]);
}
const he = /* @__PURE__ */ re(ce, [["render", ge], ["__scopeId", "data-v-7e21527a"]]), fe = {
  id: "engine.plugins.pagecontroller",
  title: "页面 JS",
  type: "plugins",
  icon: "plugin-icon-js",
  align: "top",
  confirm: "close"
  // 当点击插件栏切换或关闭前是否需要确认, 会调用插件中confirm值指定的方法，e.g. 此处指向 close方法，会调用插件的close方法执行确认逻辑
}, Le = {
  ...fe,
  apis: ie,
  entry: he
};
export {
  Le as default
};
